SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

DROP FUNCTION IF EXISTS fnGetDokumentumErtekelesekMuveszetiOktatasbanOsztalyonkent
GO

CREATE FUNCTION fnGetDokumentumErtekelesekMuveszetiOktatasbanOsztalyonkent (
   @tanevId int
  ,@osztalyCsoportId int
  ,@ertekelesTipusa int = NULL
  ,@csakTanorai bit = 1
  ,@csakKivlasztottOsztalyCsoport bit = 0
  ,@atsoroltTanuloErtekelesek int = 0
  ,@osztalyzatTipusTypeID int = 44
  ,@magatartasErtekelesTipusTypeID int = 50
  ,@szorgalomErtekelesTipusTypeID int = 51
 )
RETURNS @retTanuloErtekeles TABLE 
(
  ErtekelesId INT NOT NULL,
  Datum DATE,
  TipusId INT,
  ErtekelesSzoveg NVARCHAR(MAX),
  ErtekelesSzovegFormazott NVARCHAR(MAX),
  ErtekelesSzovegRovidNev NVARCHAR(3),
  ErtekelesOsztalyzatId INT,
  ErtekelesOsztalyzatValue INT, 
  ErtekelesOsztalyzatNev NVARCHAR(MAX),
  ErtekelesSzazalek NVARCHAR(MAX),
  MagatartasOsztalyzatId INT,
  MagatartasOsztalyzatValue INT, 
  MagatartasOsztalyzatNev NVARCHAR(MAX),
  MagatartasSzoveg NVARCHAR(MAX),
  MagatartasSzovegFormazott NVARCHAR(MAX),
  MagatartasSzovegRovidNev NVARCHAR(3),
  MagatartasErtekId INT,
  MagatartasErtek NVARCHAR(MAX),
  MagatartasErtekOsztalyzatkent INT,
  SzorgalomOsztalyzatId INT,
  SzorgalomOsztalyzatValue INT, 
  SzorgalomOsztalyzatNev NVARCHAR(MAX),
  SzorgalomSzoveg NVARCHAR(MAX),
  SzorgalomSzovegFormazott NVARCHAR(MAX),
  SzorgalomSzovegRovidNev NVARCHAR(3),
  SzorgalomErtekId INT,
  SzorgalomErtek NVARCHAR(MAX),
  SzorgalomErtekOsztalyzatkent INT,
  TanuloId INT,
  OsztalyCsoportId INT,
  TantargyId INT,
  TantargyNevZarojellel NVARCHAR(MAX),
  TantargyNevNyomtatvanyban NVARCHAR(MAX),
  TantargyNev NVARCHAR(MAX),
  TantargyAngolNev NVARCHAR(MAX),
  TantargyNemetNev NVARCHAR(MAX),
  TargyKategoriaId INT,
  FotargyE CHAR(1),
  Altantargy CHAR(1),
  FotargyId INT,
  ErtekelesTema NVARCHAR(MAX),
  ErtekeloId INT,
  ErtekelesModjaId INT,
  IsMagatartasSzorgalom CHAR(1),
  Jeloles NVARCHAR(MAX),
  JelolesAndErtekelesTema NVARCHAR(MAX),
  RENDEZ0 int,
  RENDEZ1              INT,
  RENDEZ2              NVARCHAR(MAX),
  RENDEZ3              INT,
  RENDEZ4              INT,
  RENDEZ5              NVARCHAR(MAX)
)
AS
BEGIN 
  INSERT INTO @retTanuloErtekeles
  SELECT 
    ErtekelesId,
    Datum,
    TipusId,
    ErtekelesSzoveg,
    ErtekelesSzovegFormazott,
    ErtekelesSzovegRovidNev,
    ErtekelesOsztalyzatId,
    ErtekelesOsztalyzatValue, 
    ErtekelesOsztalyzatNev,
    ErtekelesSzazalek,
    MagatartasOsztalyzatId,
    MagatartasOsztalyzatValue, 
    MagatartasOsztalyzatNev,
    MagatartasSzoveg,
    MagatartasSzovegFormazott,
    MagatartasSzovegRovidNev,
    MagatartasErtekId,
    MagatartasErtek,
    MagatartasErtekOsztalyzatkent,
    SzorgalomOsztalyzatId,
    SzorgalomOsztalyzatValue, 
    SzorgalomOsztalyzatNev,
    SzorgalomSzoveg,
    SzorgalomSzovegFormazott,
    SzorgalomSzovegRovidNev,
    SzorgalomErtekId,
    SzorgalomErtek,
    SzorgalomErtekOsztalyzatkent,
    TanuloId,
    OsztalyCsoportId,
    TantargyId,
    TantargyNevZarojellel,
    TantargyNevNyomtatvanyban,
    TantargyNev,
    TantargyAngolNev,
    TantargyNemetNev,
    TargyKategoriaId,
    FotargyE,
    Altantargy,
    FotargyId,
    ErtekelesTema,
    ErtekeloId,
    ErtekelesModjaId,
    IsMagatartasSzorgalom,
    Jeloles,
    JelolesAndErtekelesTema,
    RENDEZ0,
    RENDEZ1,              
    RENDEZ2,
    RENDEZ3,
    RENDEZ4,
    RENDEZ5
  FROM fnGetDokumentumErtekelesekOsztalyonkent(@tanevId, @osztalyCsoportId, @ertekelesTipusa, 0, @csakKivlasztottOsztalyCsoport, @atsoroltTanuloErtekelesek, DEFAULT, @osztalyzatTipusTypeID, @magatartasErtekelesTipusTypeID, @szorgalomErtekelesTipusTypeID) ErtekelesekTable
    INNER JOIN T_CSOPORT_OSSZES CsoportTable ON ErtekelesekTable.OsztalyCsoportId = CsoportTable.Id
  WHERE 
    C_TIPUSA IN
    (
       1067 --Alapf. müv. okt. zeneművészeti csoport - egyéni főtanszak
      ,1068 --Alapf. müv. okt. zeneművészeti csoport - csoportos főtanszak
      ,1069 --Alapf. müv. okt. képző- és iparművészeti csoport
      ,1070 --Alapf. müv. okt. táncművészeti csoport
      ,1071 --Alapf. müv. okt. szín- és bábművészeti csoport
      ,6756 --Alapf. műv. okt. zeneművészeti csoport - csoportos kötelezően választható
      ,6757 --Alapf. műv. okt. zeneművészeti csoport - egyéni kötelezően választható
      ,6758 --Alapf. műv. okt. zeneművészeti csoport - csoportos kötelező
      ,6759 --Alapf. műv. okt. zeneművészeti csoport - egyéni kötelező
      ,6760 --Alapf. műv. okt. zeneművészeti csoport - csoportos választható
      ,6761 --Alapf. műv. okt. zeneművészeti csoport - egyéni választható
    )
RETURN
END
GO
