DROP FUNCTION IF EXISTS fnGetTanarAltalErtekelhetoCsoportokTantargyak
GO

CREATE FUNCTION fnGetTanarAltalErtekelhetoCsoportokTantargyak(
   @pTanarId int
  ,@pTanevId int
  ,@pSzuperOsztalyfonok int
  ,@pDatum date
)
RETURNS TABLE
AS RETURN 
  SELECT 
     ocs.ID AS OsztalyCsoportId
    ,ocs.C_NEV AS Nev
    ,f.C_TANTARGYID AS TantargyId
  FROM T_OSZTALYCSOPORT_OSSZES ocs
    LEFT JOIN T_FOGLALKOZAS_OSSZES f ON ocs.ID = f.C_OSZTALYCSOPORTID
      AND f.TOROLT = 'F'
  WHERE ocs.TOROLT = 'F'
    AND ocs.C_TANEVID = @pTanevId
    AND EXISTS( SELECT 1 
                FROM T_TANULOCSOPORT_OSSZES tcs 
                WHERE tcs.C_OSZTALYCSOPORTID=ocs.ID 
                  AND tcs.TOROLT='F'
                  AND @pDatum >= tcs.C_BELEPESDATUM
                  AND (tcs.C_KILEPESDATUM IS NULL OR tcs.C_KILEPESDATUM > @pDatum)
                  AND tcs.C_TANULOID IN (SELECT ID FROM fnGetOsztalyfonokOsztalyanakTanuloi(@pTanarId, @pSzuperOsztalyfonok, ocs.C_FELADATKATEGORIAID, @pDatum)))
  UNION
  SELECT
      ocs.ID AS OsztalyCsoportId
    ,ocs.C_NEV AS Nev
    ,f.C_TANTARGYID AS TantargyId
  FROM T_FOGLALKOZAS_OSSZES f
    INNER JOIN T_OSZTALYCSOPORT_OSSZES ocs ON ocs.ID = f.C_OSZTALYCSOPORTID
      AND ocs.TOROLT = 'F'
  WHERE f.TOROLT = 'F'
    AND (f.C_TANARID = @pTanarId OR @pSzuperOsztalyfonok = 1)
    AND ocs.C_TANEVID = @pTanevId
GO