DROP PROCEDURE IF EXISTS [dbo].[sp_GetESL_A03T03_1]
GO

CREATE PROCEDURE [dbo].[sp_GetESL_A03T03_1]
   @tanevId int
  ,@intezmenyId int
  ,@feladatEllatasiHelyId int
  ,@isFelevi int = 0
  ,@osztalyzatTipusTypeID int = 44
AS
BEGIN
  SET NOCOUNT ON;

--Táblák deklarálása
declare @Dictionary table (Id int, Name nvarchar(max), Value int, Tipus nvarchar(max))
declare @Evfolyamok table (Id int, Evfolyam int)
declare @TanuloErtekeles table (Id int, Tanulo int, Ertekeles int, Tipus int)
declare @FeladatEllatasiHelyekIntezmenyhez table (FHId int, IntezmenyId int)
declare @FHhozTartozoTanulok table (Intezmeny int, FH int, Evfolyam int, TanuloId int, Neme int)

--Dátumok deklarásása
declare @kezdet int,
    @veg int,
    @felev int

select top 1 @kezdet=  iif(getdate()<=C_DATUM,1394,1400), --első félév
      @veg=  iif(getdate()<=C_DATUM,1400,1395)  --második félév
from t_tanevrendje tr where c_naptipusa=1400 and c_tanevId=@tanevId and c_intezmenyId=@intezmenyId and torolt='F'

DECLARE @FelevKezdete DATE = (select top 1 c_datum from t_tanevrendje tr where c_naptipusa=@kezdet and c_tanevid=@tanevid and c_intezmenyid=@intezmenyid and torolt='F')
DECLARE @FelevVege DATE = (select top 1 c_datum from t_tanevrendje tr where c_naptipusa=@veg and c_tanevid=@tanevid and c_intezmenyid=@intezmenyid and torolt='F')

INSERT INTO @FHhozTartozoTanulok (TanuloId, Evfolyam, Neme)
SELECT tanulok.TanuloId, tanulok.Evfolyam, tanulok.Neme FROM fnGetLemorzsolodottTanulokByFelhely(@feladatEllatasiHelyId, @tanevId, @isFelevi, @osztalyzatTipusTypeID) as tanulok

--adott évben évismétlés 
declare @OsszesEvismetloTanulo int =(select count(fht.TanuloId) from @FHhozTartozoTanulok fht
  inner join t_tanulo t on t.C_EVISMETLO='T' and fht.TanuloId=t.id AND @isFelevi = 0)

declare @OsszesEvismetloTanuloLany int =(select count(fht.TanuloId) from @FHhozTartozoTanulok fht
  inner join t_tanulo t on t.c_evismetlo='T' and fht.TanuloId=t.id and fht.TanuloId=t.id and fht.Neme=5 AND @isFelevi = 0)

select 'AzAdottTanitasiEvbenEvismetlesreKotelezett' as Leiras, [1307] 'Evfolyam5', [1308] 'Evfolyam6', [1309] 'Evfolyam7', [1310] 'Evfolyam8', [1311] 'Evfolyam9', [1312] 'Evfolyam10', [1313] 'Evfolyam11', [1314] 'Evfolyam12', [6471] 'KH1', [6474] 'KH2', [6477] 'SzH1', [6478] 'SzH2',  @OsszesEvismetloTanulo 'Osszesen', @OsszesEvismetloTanuloLany 'Lany' 
 from (select fht.TanuloId Tanulo, fht.Evfolyam Evfolyam from @FHhozTartozoTanulok fht
  inner join t_tanulo t on t.c_evismetlo='T' and fht.TanuloId=t.id and fht.TanuloId=t.id  AND @isFelevi = 0
union 
select null, null where (select top 1 fht.TanuloId from @FHhozTartozoTanulok fht
  inner join t_tanulo t on t.c_evismetlo='T' and fht.TanuloId=t.id and fht.TanuloId=t.id) is null AND @isFelevi = 0)a
pivot (count(Tanulo) for Evfolyam in ([1307], [1308], [1309], [1310], [1311], [1312], [1313], [1314], [6471], [6474], [6477], [6478]))piv

END
GO
