DROP PROCEDURE IF EXISTS [dbo].[sp_GetErtekelesFotargyiFoglalkozasData]
GO

-- =============================================
-- Description:  <Felhasznlhoz kthet foglalkozsok ftrgy adatai az rtkelsek szrshez>
-- =============================================

CREATE PROCEDURE [dbo].[sp_GetErtekelesFotargyiFoglalkozasData]
   @pTanarId INT
  ,@pTanevId INT
AS
BEGIN

  SET NOCOUNT ON;

  SELECT DISTINCT
     MAX(foglalkozas.ID)                ID
    ,foglalkozas.C_OSZTALYCSOPORTID            OsztalyCsoportId
    ,fotargy.ID                     TantargyId
    ,MAX(fotargy.C_NEV)                  TantargyNev
    ,MAX(osztalyCsoport.C_NEV + ' - ' + fotargy.C_NEV)  Nev
    ,MAX(osztalyCsoport.C_EVFOLYAMTIPUSA)        Evfolyam
    ,MAX(osztalyCsoport.C_NEV)              OsztalyCsoportNev
    ,MAX(csoport.C_TIPUSA)                  CsoportTipusId
  FROM
    T_FOGLALKOZAS_OSSZES foglalkozas
  LEFT JOIN
    T_OSZTALYCSOPORT_OSSZES osztalyCsoport ON
        osztalyCsoport.ID = foglalkozas.C_OSZTALYCSOPORTID
      AND osztalyCsoport.C_TANEVID = @pTanevId
      AND osztalyCsoport.TOROLT = 'F'
  LEFT JOIN
    T_CSOPORT_OSSZES csoport ON
        csoport.ID = foglalkozas.C_OSZTALYCSOPORTID
      AND csoport.C_ALTANEVID = @pTanevId
      AND csoport.TOROLT = 'F'
  LEFT JOIN
    T_TANTARGY_OSSZES tantargy ON
        tantargy.ID = foglalkozas.C_TANTARGYID
      AND tantargy.C_TANEVID = @pTanevId
      AND tantargy.TOROLT = 'F'
  LEFT JOIN
    T_FELHASZNALO_OSSZES felhasznalo ON
        felhasznalo.ID = foglalkozas.C_TANARID
      AND felhasznalo.C_TANEVID = @pTanevId
      AND felhasznalo.TOROLT = 'F'
  LEFT JOIN
    T_TANTARGY_OSSZES fotargy ON
        fotargy.C_TANEVID = @pTanevId
      AND  fotargy.C_FOTARGYE = 'T'
      AND fotargy.TOROLT = 'F'
      AND fotargy.ID IN (
        SELECT
          C_FOTARGYID
        FROM
          T_TANTARGY_OSSZES
        WHERE
            ID = foglalkozas.C_TANTARGYID
          AND C_TANEVID = @pTanevId
          AND TOROLT = 'F'
      )
  WHERE
      fotargy.ID IS NOT NULL
    AND  foglalkozas.C_TANARID = @pTanarId
    AND  foglalkozas.C_TANEVID = @pTanevId
    AND  foglalkozas.TOROLT = 'F'
  GROUP BY
     foglalkozas.C_OSZTALYCSOPORTID
    ,fotargy.ID
  ORDER BY
     Evfolyam      ASC
    ,OsztalyCsoportNev  ASC
    ,TantargyNev    ASC

END

GO

