DROP PROCEDURE IF EXISTS [dbo].[sp_GetNapkozisCsoportTanuloinakHaviMulasztasiOsszesitoje_1]
GO

CREATE PROCEDURE [dbo].[sp_GetNapkozisCsoportTanuloinakHaviMulasztasiOsszesitoje_1] 
  @tanevID int,
  @intezmenyId int,
  @csoportid int,
  @honap int

AS 
BEGIN
SET NOCOUNT ON;

--Napközis csoportok tan
create table #tanulo (Id int, Osztaly int)
insert into #tanulo
  select tcs.c_tanuloid Tanulo, tcs.c_osztalycsoportid as Csoport from t_csoport cs
    inner join t_osztalycsoport ocs on ocs.id=cs.id
    inner join t_tanulocsoport tcs on tcs.c_osztalycsoportid=ocs.id
  where cs.c_tipusa=1035 and cs.c_altanevid=@tanevid and cs.c_alintezmenyid=@intezmenyid and cs.torolt='F' and tcs.c_osztalycsoportid=@csoportid

--Igazolások és típusai
create table #igazolas (Tanulo int, IgazoltE nvarchar(1), IgazolasTipus int)
insert into #igazolas
  select tm.c_oratanuloiid as Tanulo, tm.c_igazolt as IgazoltE, tm.c_igazolastipusa as IgazolasTipus from t_tanulomulasztas tm
    inner join t_tanitasiora tao on tao.id=tm.c_tanitasiorakid and tao.torolt='F' and tao.c_tanevid=@tanevid and tao.c_intezmenyid=@intezmenyid and (CAST(MONTH(tao.c_datum) AS VARCHAR))=@honap 
    inner join t_csoport cs on cs.id=tao.c_osztalycsoportid and cs.c_tipusa=1035
  where tm.torolt='F' and tm.c_intezmenyid=@intezmenyid and tm.c_tanevid=@tanevid

--Mulasztások
create table #mulasztas (Nap int, Tanulo int, Osztaly int)
insert into #mulasztas
  select CAST(DAY(tao.c_datum) as int) as Nap, tm.c_oratanuloiid as Tanulo, tao.c_osztalycsoportid as Osztaly from t_tanulomulasztas tm
    inner join t_tanitasiora tao on tao.id=tm.c_tanitasiorakid and tao.torolt='F' and tao.c_tanevid=@tanevid and tao.c_intezmenyid=@intezmenyid and (CAST(MONTH(tao.c_datum) AS VARCHAR))=@honap 
    inner join t_csoport cs on cs.id=tao.c_osztalycsoportid and cs.c_tipusa=1035
  where tm.torolt='F' and tm.c_intezmenyid=@intezmenyid and tm.c_tanevid=@tanevid

select f.c_nyomtatasinev as COLUMN379, 
  iif(m.[1]=0, null, m.[1]) as [1], iif(m.[2]=0, null, m.[2]) as [2], iif(m.[3]=0, null, m.[3]) as [3], iif(m.[4]=0, null, m.[4]) as [4], iif(m.[5]=0, null, m.[5]) as [5],
  iif(m.[6]=0, null, m.[6]) as [6], iif(m.[7]=0, null, m.[7]) as [7], iif(m.[8]=0, null, m.[8]) as [8], iif(m.[9]=0, null, m.[9]) as [9], iif(m.[10]=0, null, m.[10]) as [10],
  iif(m.[11]=0, null, m.[11]) as [11], iif(m.[12]=0, null, m.[12]) as [12], iif(m.[13]=0, null, m.[13]) as [13], iif(m.[14]=0, null, m.[14]) as [14], iif(m.[15]=0, null, m.[15]) as [15],
  iif(m.[16]=0, null, m.[16]) as [16], iif(m.[17]=0, null, m.[17]) as [17], iif(m.[18]=0, null, m.[18]) as [18], iif(m.[19]=0, null, m.[19]) as [19], iif(m.[20]=0, null, m.[20]) as [20],
  iif(m.[21]=0, null, m.[21]) as [21], iif(m.[22]=0, null, m.[22]) as [22], iif(m.[23]=0, null, m.[23]) as [23], iif(m.[24]=0, null, m.[24]) as [24], iif(m.[25]=0, null, m.[25]) as [25],
  iif(m.[26]=0, null, m.[26]) as [26], iif(m.[27]=0, null, m.[27]) as [27], iif(m.[28]=0, null, m.[28]) as [28], iif(m.[29]=0, null, m.[29]) as [29], iif(m.[30]=0, null, m.[30]) as [30],
  iif(m.[31]=0, null, m.[31]) as [31]
  , Osszes.Osszes as COLUMN2672, Igazolt.Igazolt as COLUMN2568, Egyeb.Egyeb as COLUMN5197, Orvosi.Orvosi as COLUMN1786, Szuloi.Szuloi as COLUMN1787, Hivatalos.Hivatalos as COLUMN1788, IskolaErdeku.IskolaErdeku as COLUMN1789, Igazolatlan.Igazolatlan as COLUMN1911
  from #tanulo t
  left join (select * from #mulasztas m pivot (count(Osztaly) for Nap in ([1],[2],[3],[4],[5],[6],[7],[8],[9],[10],[11],[12],[13],[14],[15],[16],[17],[18],[19],[20],[21],[22],[23],[24],[25],[26],[27],[28],[29],[30],[31]))pv)m on m.Tanulo=t.id
  left join (select Tanulo, count(Tanulo) as Osszes from #igazolas group by Tanulo) Osszes on Osszes.Tanulo=t.Id
  left join (select Tanulo, count(Tanulo) as Igazolt from #igazolas i where i.IgazoltE='T' group by Tanulo) Igazolt on Igazolt.Tanulo=t.Id
  left join (select Tanulo, count(Tanulo) as Igazolatlan from #igazolas i where i.IgazoltE='F' group by Tanulo) Igazolatlan on Igazolatlan.Tanulo=t.Id
  left join (select Tanulo, count(Tanulo) as Egyeb from #igazolas i where i.IgazolasTipus=1529 group by Tanulo) Egyeb on Egyeb.Tanulo=t.Id
  left join (select Tanulo, count(Tanulo) as Orvosi from #igazolas i where i.IgazolasTipus=1530 group by Tanulo) Orvosi on Orvosi.Tanulo=t.Id
  left join (select Tanulo, count(Tanulo) as Szuloi from #igazolas i where i.IgazolasTipus=1531 group by Tanulo) Szuloi on Szuloi.Tanulo=t.Id
  left join (select Tanulo, count(Tanulo) as Hivatalos from #igazolas i where i.IgazolasTipus=1532 group by Tanulo) Hivatalos on Hivatalos.Tanulo=t.Id
  left join (select Tanulo, count(Tanulo) as IskolaErdeku from #igazolas i where i.IgazolasTipus=1533 group by Tanulo) IskolaErdeku on IskolaErdeku.Tanulo=t.Id
  inner join t_felhasznalo f on f.id=t.Id
order by f.c_nyomtatasinev

drop table #mulasztas
drop table #tanulo
drop table #igazolas

END 

GO

