-- =============================================
-- Author:    Kelemen Attila
-- Create date: 2016.04.05.
-- Description:  Tanév rendjében tárolt negyedévekhez tartozó dátumok
-- =============================================
DROP PROCEDURE IF EXISTS [dbo].[sp_GetTanevrendNegyedevek]
GO

CREATE PROCEDURE [dbo].[sp_GetTanevrendNegyedevek]
  @elsonap int,
  @I_negyedev_vege int,
  @felevvege int,
  @III_negyedev_vege int,
  @utolsonap int
AS
BEGIN
SET NOCOUNT ON;
    SELECT
      'Elso_Nap' Tipus ,
      C_DATUM Datum
    FROM T_TANEVRENDJE_OSSZES
      INNER JOIN T_TANEV_OSSZES ON T_TANEVRENDJE_OSSZES.C_TANEVID = T_TANEV_OSSZES.ID
    WHERE T_TANEV_OSSZES.C_AKTIV = 'T' AND T_TANEV_OSSZES.TOROLT='F' AND T_TANEVRENDJE_OSSZES.TOROLT='F' AND C_NAPTIPUSA = @elsonap

  UNION ALL

    SELECT
      'I_Negyedev_Vege' Tipus ,
      C_DATUM Datum
    FROM T_TANEVRENDJE_OSSZES
      INNER JOIN T_TANEV_OSSZES ON T_TANEVRENDJE_OSSZES.C_TANEVID = T_TANEV_OSSZES.ID
    WHERE T_TANEV_OSSZES.C_AKTIV = 'T' AND T_TANEV_OSSZES.TOROLT='F' AND T_TANEVRENDJE_OSSZES.TOROLT='F' AND C_NAPTIPUSA = @I_negyedev_vege

  UNION ALL

    SELECT
      'Felev_Vege' Tipus ,
      C_DATUM Datum
    FROM T_TANEVRENDJE_OSSZES
      INNER JOIN T_TANEV_OSSZES ON T_TANEVRENDJE_OSSZES.C_TANEVID = T_TANEV_OSSZES.ID
    WHERE T_TANEV_OSSZES.C_AKTIV = 'T' AND T_TANEV_OSSZES.TOROLT='F' AND T_TANEVRENDJE_OSSZES.TOROLT='F' AND C_NAPTIPUSA = @felevvege

  UNION ALL

    SELECT
      'III_Negyedev_Vege' Tipus ,
      C_DATUM Datum
    FROM T_TANEVRENDJE_OSSZES
      INNER JOIN T_TANEV_OSSZES ON T_TANEVRENDJE_OSSZES.C_TANEVID = T_TANEV_OSSZES.ID
    WHERE T_TANEV_OSSZES.C_AKTIV = 'T' AND T_TANEV_OSSZES.TOROLT='F' AND T_TANEVRENDJE_OSSZES.TOROLT='F' AND C_NAPTIPUSA = @III_negyedev_vege

  UNION ALL

    SELECT
      'Utolso_Nap' Tipus ,
      C_DATUM Datum
    FROM T_TANEVRENDJE_OSSZES
      INNER JOIN T_TANEV_OSSZES ON T_TANEVRENDJE_OSSZES.C_TANEVID = T_TANEV_OSSZES.ID
    WHERE T_TANEV_OSSZES.C_AKTIV = 'T' AND T_TANEV_OSSZES.TOROLT='F' AND T_TANEVRENDJE_OSSZES.TOROLT='F' AND C_NAPTIPUSA = @utolsonap
END
GO