﻿DROP PROCEDURE IF EXISTS sp_IsAlkalmazottPedagogus
GO

-- =============================================
-- Description:  <Előszedjük, hogy a felhasználó pedagógus-e>
-- =============================================
CREATE PROCEDURE sp_IsAlkalmazottPedagogus
   @pIntezmenyId          INT
  ,@pTanevId            INT
  ,@pAlkalmazottId        INT
  ,@pBesorolasiFokozatTipusNa    INT

AS
BEGIN

  SET NOCOUNT ON;
    IF EXISTS (
      SELECT 1
      FROM
        T_ALKALMAZOTT_OSSZES Alkalmazott
      INNER JOIN
        T_MUNKAUGYIADATOK_OSSZES MunkaugyiAdatok ON
            MunkaugyiAdatok.C_ALKALMAZOTTID = Alkalmazott.ID
          AND  MunkaugyiAdatok.C_INTEZMENYID = @pIntezmenyId
          AND MunkaugyiAdatok.C_TANEVID = @pTanevId
          AND MunkaugyiAdatok.TOROLT = 'F'
          AND MunkaugyiAdatok.C_BESOROLASIFOKOZAT <> @pBesorolasiFokozatTipusNa
      WHERE
          Alkalmazott.ID = @pAlkalmazottId
        AND  Alkalmazott.C_ALINTEZMENYID = @pIntezmenyId
        AND Alkalmazott.C_ALTANEVID = @pTanevId
        AND Alkalmazott.TOROLT = 'F'
    )
      SELECT 1
    ELSE
      SELECT 0

END
GO
