-- =============================================
-- Description:  Tanuló kirstat adatokat ad vissza az exorthoz 
-- =============================================
DROP PROCEDURE IF EXISTS [dbo].[sp_TanuloKIRStatAdatokGyorsExport]
GO

CREATE PROCEDURE [dbo].[sp_TanuloKIRStatAdatokGyorsExport]
    @pTanevId          INT
AS
BEGIN
  SET NOCOUNT ON;
    SELECT
                   felhasznalo.C_NYOMTATASINEV as 'Tanuló neve'
                  ,felhasznalo.C_OKTATASIAZONOSITO as 'Tanuló oktatási azonosító'
                  ,felhasznalo.C_SZULETESINEV as 'Születési neve'
                  ,CAST(felhasznalo.C_SZULETESIDATUM as date) as 'Születési dátuma'
                  ,felhasznalo.C_ANYJANEVE as 'Anyja neve'
                  ,szuletesiorszag.C_NAME as 'Születési ország'
                  ,felhasznalo.C_SZULETESIHELY as 'Születési hely'
                  ,neme.C_NAME as 'Neme'
            ,allampolgarsaga.C_NAME as 'Állampolgársága'
            ,allampolgarsaga2.C_NAME as 'Állampolgársága 2'
            ,anyanyelve.C_NAME as 'Anyanyelve'
                  ,ocs.C_NEV as 'Osztály neve'
                  ,evfolyam.C_NAME as 'Évfolyam neve'
                  ,mukodesihely.C_NEV + ' - ' + oktatasinevelesifeladat.C_NAME as 'Feladatellátási hely'
            ,felhasznalo.C_ADOAZONOSITOJEL as 'Adószám'
                  ,felhasznalo.C_TAJSZAM as 'Tajszám'
                  ,igazolvanytipus.C_NAME as 'Igazolvány típusa'
          ,felhasznalo.C_IGAZOLVANYSZAM as 'Igazolványszám'
          ,tta.C_TORZSLAPSZAM as 'Törzslapszám'
                  ,tta.C_NAPLOSORSZAM as 'Naplósorszám'
          ,CAST(tta.C_NYILVANTARTASKEZDETE as date) as 'Nyilvántartás kezdete'
          ,tanulo.C_BANKSZAMLASZAM as 'Bankszámlaszám'
          ,tta.C_BEIRASINAPLOSORSZAM as 'Beírási napló sorszáma'
          ,IIF(tta.C_EVISMETLO = 'T', 'Igen', 'Nem') as 'Évfolyamismétlő'
          ,tanulo.C_EVISMETLOTANTARGYAK as 'Évismétlés tantárgyai'
                  ,IIF(tta.C_JOGVISZONYATSZUNETELTETO = 'T', 'Igen', 'Nem') as 'Jogviszonyát szüneteltető'
                  ,CAST(tta.C_JOGVISZONYVARHATOBEFEJEZESE as date) as 'Jogviszony várható befejezése'
                  ,IIF(tta.C_POLGARISZERZODESES = 'T', 'Igen', 'Nem') as 'Polgári szerződéses'
                  ,IIF(tta.C_EGYUTTMUKODESES = 'T', 'Igen', 'Nem') as 'Együttműködési megállapodásos'
                  ,IIF(tanulo.C_MEGALLAPODASOS = 'T', 'Igen', 'Nem') as 'Kizárólag iskolai keretek között, tanműhelyben tanuló'
                  ,IIF(tta.C_SZAKMAIGYAKORLATON = 'T', 'Igen', 'Nem') as 'Szakmai gyakorlaton'
                  ,IIF(tta.C_VENDEG = 'T', 'Igen', 'Nem') as 'Vendégtanuló'
                  ,IIF(tta.C_MAGANTANULO = 'T', 'Igen', 'Nem') as 'Magántanuló / Egyéni munkarend'
          ,magantanulosagoka.C_NAME as 'Magántanulóság / Egyéni munkarend oka'
          ,CAST(tta.C_MAGANTANULOSAGKEZDETE as date) as 'Magántanulóság / Egyéni munkarend kezdete'
          ,CAST(tanulo.C_DIAKIGAZOLVANYKELTE as date) as 'Diákigazolvány kelte'
          ,tanulo.C_DIAKIGAZOLVANYSZAM as 'Diákigazolvány száma'
                  ,IIF(tta.C_BEJARO = 'T', 'Igen', 'Nem') as 'Bejáró'
                  ,IIF(tta.C_TANKOTELEZETT = 'T', 'Igen', 'Nem') as 'Tankötelezett'
                  ,CAST(tta.C_TANKOTELEZETTSEGVEGE as date) as 'Tankötelezettség vége'
                  ,IIF(tta.C_TANULOSZERZODESES = 'T', 'Igen', 'Nem') as 'Tanulószerződéses'
                  ,IIF(tta.C_TANDIJATFIZETO = 'T', 'Igen', 'Nem') as 'Tandíjat fizető'
                  ,IIF(tta.C_TERITESIDIJATFIZETO = 'T', 'Igen', 'Nem') as 'Térítésidíjat fizető'
                  ,vallasa.C_NAME as 'Vallása'
                  ,tanulo.C_EGYHAZKOZOSSEGE as 'Egyházközössége'
          ,IIF(tta.C_DIAKSPORTKOROS = 'T', 'Igen', 'Nem') as 'Diáksportkör tagja'
                  ,tanulo.C_SPORTAG as 'Sportága'
          ,tanulo.C_SPORTEDZONEVE as 'Sportedző neve'
            ,tanulo.C_SPORTKLUB as 'Sportklub'
                  ,testnevelestipusa.C_NAME as 'Testnevelés típusa'
                  ,IIF(tanulo.C_KOLLEGIUMIELLATASOS = 'T', 'Igen', 'Nem') as 'Kollégiumi ellátásos'
                  ,ingyenestankonyv.C_NAME as 'Ingyenes tankönyvellátás'
                  ,etkezesikedvezmeny.C_NAME as 'Étkezési kedvezmény'
                  ,IIF(tanulo.C_SZOCIALISTAMOGATAS = 'T', 'Igen', 'Nem') as 'Szociális ösztöndíj'
          ,IIF(tanulo.C_ALLAMIGONDOZOTT = 'T', 'Igen', 'Nem') as 'Intézeti, állami nevelt'
                  ,IIF(tanulo.C_VESZELYEZTETETT = 'T', 'Igen', 'Nem') as 'Veszélyeztetett'
                  ,hatranyoshelyzet.C_NAME as 'Hátrányos helyzetű'
                  ,IIF(tanulo.C_BEILLESZKEDESINEHEZSEG = 'T', 'Igen', 'Nem') as 'Beilleszkedési nehézség'
                  ,tanulo.C_RENDSZERESGYERMEKVEDELMIKEDV as 'Rendszeres gyermekvédelmi kedvezmény'
                  ,IIF(tanulo.C_MENEDEKJOGGALRENDELKEZO = 'T', 'Igen', 'Nem') as 'Menekült, oltalmazott, menedékes'
                  ,tanulo.C_TARTOSGYOGYKEZELESSZAMA as 'Tartós gyógykezelés okmányszáma'
          ,tanulo.C_TOBBGYERMEKIGAZOLASSZAMA as '3 vagy több gyermek igazolás okmányszáma'
                  ,tanulo.C_TANULOIJOGVISZONYOSELTARTOTT as 'Tanulói, hallgatói jogviszonnyal rendelkező eltartott'
                  ,tanulo.C_SAJATOSNEVELESU as 'Sajátos nevelési igényű'
          ,tanulo.C_SNILETSZAMSULY as 'Tanuló létszámsúlyozása'
                  ,IIF(tanulo.C_HALMOZOTTANFOGYATEKOS = 'T', 'Igen', 'Nem') as 'Halmozottan fogyatékos'
            ,tanulo.C_SNIKIALLITOINTEZMENY as 'Kiállító intézmény megnevezése'
          ,tanulo.C_SNIKONTROLLIDOPONT as 'Szükséges kontroll időpontja'
          ,tanulo.C_SNIMEGHATAROZAS as 'SNI meghatározás'
          ,tanulo.C_SNIOKMANYERVENYESSEGKEZDETE as 'SNI okmány érvényesség kezdete'
          ,tanulo.C_SNIOKMANYERVENYESSEGVEGE as 'SNI okmány érvényesség vége'
          ,tanulo.C_BNOKOD as 'BNO-kód'
                  ,ertelmifogyatekos.C_NAME as 'Értelmi fogyatékos' --
          ,tanulo.C_ERTELMIFOGYATEKOSOKMANYSZAM as 'Értelmi fogyatékos okmányszám'
          ,hallasserult.C_NAME as 'Hallássérült' --
          ,tanulo.C_HALLASSERULTOKMANYSZAM as 'Hallássérült okmányszám'
          ,latasserult.C_NAME as 'Látássérült' --
          ,tanulo.C_LATASSERULTOKMANYSZAM as 'Látássérült okmányszám'
          ,tanulo.C_MOZGASSERULTOKMANYSZAM as 'Mozgáskorlátozott okmányszám'
                  ,tanulo.C_BESZEDFOGYATEKOSOKMANYSZAM as 'Beszédfogyatékos okmányszám'
          ,tanulo.C_DISZGRAFIAOKMANYSZAM as 'Diszgráfia okmányszám'
          ,tanulo.C_DISZKALKULIAOKMANYSZAM as 'Diszkalkulia okmányszám'
          ,tanulo.C_DISZLEXIAOKMANYSZAM as 'Diszlexia okmányszám'
                  ,tanulo.C_VISELKEDESORGANIKUSOKMANYSZA as 'Viselkedés fejlődésének organikus okra visszavezethető tartós és súlyos rendellenességével küzd okmányszám'
                  ,tanulo.C_VISELKEDESNEMORGANIKUSOKMANY as 'Viselkedés fejlődésének organikus okra vissza nem vezethető tartós és súlyos rendellenességével küzd okmányszám'
                  ,tanulo.C_MEGISMEROORGANIKUSOKMANYSZAM as 'Megismerő funkciók organikus okra visszavezethető tartós és súlyos rendellenességével küzd okmányszám'
                  ,tanulo.C_MEGISMERONEMORGANIKUSOKMANYS as 'Megismerő funkciók organikus okra vissza nem vezethető tartós és súlyos rendellenességével küzd okmányszám'
          ,tanulo.C_FEJLESZTOFOGLALKOZASORASZAM as 'Fejlesztésre fordítandó óraszám'
                  ,tanulo.C_FEJLESZTOFOGLALKOZAS as 'Fejlesztő foglalkozás'
                  ,tanulo.C_FEJLESZTESREKIJELOLT as 'Fejlesztésre kijelölt'
                  ,IIF(tanulo.C_BTMPROBLEMAS = 'T', 'Igen', 'Nem') as 'Beilleszkedési, tanulási és magatartási nehézséggel küzdő'
                  ,tanulo.C_BTMLETSZAMSULY as 'Tanuló létszámsúlyozása'
                  ,IIF(tanulo.C_BEILLESZKEDESIPROBLEMAVALKUZ = 'T', 'Igen', 'Nem') as 'Beilleszkedési problémával küzd'
                  ,IIF(tanulo.C_TANULASIPROBLEMAVALKUZD = 'T', 'Igen', 'Nem') as 'Tanulási problémával küzd'
                  ,IIF(tanulo.C_MAGATARTASIPROBLEMAVALKUZD = 'T', 'Igen', 'Nem') as 'Magatartási problémával küzd'
                  ,tanulo.C_BTMHATAROZATOKMANYSZAM as 'BTM határozat okmányszáma'
          ,tanulo.C_BTMKIALLITOINTEZMENY as 'Kiállító intézmény megnevezése'
          ,tanulo.C_BTMKONTROLLIDOPONT as 'Kontroll időpontja'
          ,tanulo.C_BTMOKMANYERVENYESSEGKEZDETE as 'Okmány érvényességének kezdete'
          ,tanulo.C_BTMOKMANYERVENYESSEGVEGE as 'Okmány érvényességének vége'
                  ,tanulo.C_BTMHATAROZATTARTALMA as 'Határozat tartalma'
                  ,IIF(tanulo.C_KOZEPFOKUOKTATASBATIZENHATOD = 'T', 'Igen', 'Nem') as 'Középfokú oktatásba 16. életévét betöltve került'
          ,szakmacsoport.C_NAME as 'Szakmacsoport'
                  ,agazat.C_NAME as 'Ágazat'
                  ,szakkepesites.C_NAME as 'Szakképesítés'
          ,CONCAT(ISNULL(szakkepesitestipus.C_SZAKKEPESITESSZINT, ''), ISNULL(szakkepesitestipus.C_TANULMANYITERULET,''), ISNULL(szakkepesitestipus.C_TERULETSORSZAM,'')) as 'Szakképesítés (kód)'
            ,resszakkepesites.C_NAME as 'Részszakképesítés'
          ,tanulo.C_SZAKKEPESITESSZAMA as 'Szakképesítés száma'
                  ,IIF(tta.C_OSZTV = 'T', 'Igen', 'Nem') as 'OSZTV országos döntős'
                  ,IIF(tta.C_SZKTV = 'T', 'Igen', 'Nem') as 'SZKTV országos döntős'
                  ,IIF(tta.C_SZETVAGAZAT = 'T', 'Igen', 'Nem') as 'SZÉTV országos döntő'
                  ,IIF(tta.C_EGYEBORSZAGOSDONTO = 'T', 'Igen', 'Nem') as 'Egyéb országos döntő'
                  ,IIF(tta.C_TECHNIKUSIEVFOLYAM = 'T', 'Igen', 'Nem') as 'Technikusi évfolyam'
          ,tta.C_SZINTVIZSGA as 'Gyakorlati szintvizsgák átlaga'
          ,felhasznalo.C_MEGJEGYZES as 'Megjegyzés'
FROM T_TANULO_OSSZES tanulo
  INNER JOIN T_FELHASZNALO_OSSZES felhasznalo ON felhasznalo.ID = tanulo.ID AND felhasznalo.C_TANEVID = tanulo.C_ALTANEVID AND felhasznalo.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND felhasznalo.TOROLT = 'F'
  INNER JOIN T_TANEV_OSSZES tanev ON tanev.ID = @pTanevId
  INNER JOIN T_TANULOCSOPORT_OSSZES tanulocsoport ON tanulocsoport.C_TANULOID = tanulo.ID AND tanulocsoport.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND tanulocsoport.C_TANEVID = tanulo.C_ALTANEVID AND tanulocsoport.TOROLT = 'F' AND tanulocsoport.C_BELEPESDATUM <= DATEADD(DAY, 30, tanev.C_KEZDONAP) AND (tanulocsoport.C_KILEPESDATUM >= DATEADD(DAY, 30, tanev.C_KEZDONAP) OR tanulocsoport.C_KILEPESDATUM IS NULL)
  INNER JOIN T_TANULOTANUGYIADATOK_OSSZES tta ON tta.C_TANULOCSOPORTID = tanuloCsoport.ID AND tta.TOROLT = 'F'
  INNER JOIN T_OSZTALYCSOPORT_OSSZES ocs ON ocs.ID = tanulocsoport.C_OSZTALYCSOPORTID AND ocs.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND ocs.C_TANEVID = tanulo.C_ALTANEVID AND ocs.TOROLT = 'F' AND ocs.C_FELADATKATEGORIAID = 7553 /*OktNevelesiKategoriaEnum.Alapkepzes*/
  INNER JOIN T_OSZTALY_OSSZES osztaly ON osztaly.ID = tanulocsoport.C_OSZTALYCSOPORTID AND osztaly.C_ALINTEZMENYID = tanulo.C_ALINTEZMENYID AND osztaly.C_ALTANEVID = tanulo.C_ALTANEVID AND osztaly.TOROLT = 'F'
  INNER JOIN T_DICTIONARYITEMBASE_OSSZES evfolyam ON evfolyam.ID = ocs.C_EVFOLYAMTIPUSA AND evfolyam.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND evfolyam.C_TANEVID = tanulo.C_ALTANEVID AND evfolyam.TOROLT = 'F'
  INNER JOIN T_FELADATELLATASIHELY_OSSZES felhely ON felhely.ID = ocs.C_FELADATELLATASIHELYID AND felhely.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND felhely.C_TANEVID = tanulo.C_ALTANEVID AND felhely.TOROLT = 'F'
  INNER JOIN T_DICTIONARYITEMBASE_OSSZES oktatasinevelesifeladat ON oktatasinevelesifeladat.ID = felhely.C_OKTATASINEVELESIFELADATTIPUS AND oktatasinevelesifeladat.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND oktatasinevelesifeladat.C_TANEVID = tanulo.C_ALTANEVID AND oktatasinevelesifeladat.TOROLT = 'F'
  INNER JOIN T_MUKODESIHELY_OSSZES mukodesihely ON mukodesihely.ID = felhely.C_MUKODESIHELYID AND mukodesihely.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND mukodesihely.C_TANEVID = tanulo.C_ALTANEVID AND mukodesihely.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES neme ON neme.ID = felhasznalo.C_NEME AND neme.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND neme.C_TANEVID = tanulo.C_ALTANEVID AND neme.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES allampolgarsaga ON allampolgarsaga.ID = felhasznalo.C_ALLAMPOLGARSAGA AND allampolgarsaga.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND allampolgarsaga.C_TANEVID = tanulo.C_ALTANEVID AND allampolgarsaga.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES szuletesiorszag ON szuletesiorszag.ID = felhasznalo.C_SZULETESIORSZAG AND szuletesiorszag.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND szuletesiorszag.C_TANEVID = tanulo.C_ALTANEVID AND szuletesiorszag.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES allampolgarsaga2 ON allampolgarsaga2.ID = felhasznalo.C_ALLAMPOLGARSAGA2 AND allampolgarsaga2.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND allampolgarsaga2.C_TANEVID = tanulo.C_ALTANEVID AND allampolgarsaga2.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES anyanyelve ON anyanyelve.ID = felhasznalo.C_ANYANYELVE AND anyanyelve.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND anyanyelve.C_TANEVID = tanulo.C_ALTANEVID AND anyanyelve.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES igazolvanytipus ON igazolvanytipus.ID = felhasznalo.C_IGAZOLVANYTIPUSA AND igazolvanytipus.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND igazolvanytipus.C_TANEVID = tanulo.C_ALTANEVID AND igazolvanytipus.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES magantanulosagoka ON magantanulosagoka.ID = tta.C_MAGANTANULOSAGANAKOKAID AND magantanulosagoka.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND magantanulosagoka.C_TANEVID = tanulo.C_ALTANEVID AND magantanulosagoka.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES ingyenestankonyv ON ingyenestankonyv.ID = tanulo.C_INGYENESTANKONVYELLATASA AND ingyenestankonyv.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND ingyenestankonyv.C_TANEVID = tanulo.C_ALTANEVID AND ingyenestankonyv.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES etkezesikedvezmeny ON etkezesikedvezmeny.ID = tanulo.C_ETKEZESIKEDVEZMENY AND etkezesikedvezmeny.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND etkezesikedvezmeny.C_TANEVID = tanulo.C_ALTANEVID AND etkezesikedvezmeny.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES vallasa ON vallasa.ID = tanulo.C_VALLASA AND vallasa.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND vallasa.C_TANEVID = tanulo.C_ALTANEVID AND vallasa.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES testnevelestipusa ON testnevelestipusa.ID = tanulo.C_TESTNEVELESTIPUSA AND testnevelestipusa.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND testnevelestipusa.C_TANEVID = tanulo.C_ALTANEVID AND testnevelestipusa.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES szakmacsoport ON szakmacsoport.ID = tta.C_SZAKMACSOPORTID AND szakmacsoport.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND szakmacsoport.C_TANEVID = tanulo.C_ALTANEVID AND szakmacsoport.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES agazat ON agazat.ID = tta.C_AGAZATID AND agazat.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND agazat.C_TANEVID = tanulo.C_ALTANEVID AND agazat.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES szakkepesites ON szakkepesites.ID = tta.C_SZAKKEPESITESID AND szakkepesites.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND szakkepesites.C_TANEVID = tanulo.C_ALTANEVID AND szakkepesites.TOROLT = 'F'
  LEFT JOIN T_SZAKKEPESITESTIPUS_OSSZES szakkepesitestipus ON szakkepesites.ID = szakkepesitestipus.ID AND szakkepesites.C_INTEZMENYID = szakkepesitestipus.C_ALINTEZMENYID AND szakkepesites.C_TANEVID = szakkepesitestipus.C_ALTANEVID AND szakkepesitestipus.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES resszakkepesites ON resszakkepesites.ID = tta.C_RESZSZAKKEPESITESID AND resszakkepesites.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND resszakkepesites.C_TANEVID = tanulo.C_ALTANEVID AND resszakkepesites.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES ertelmifogyatekos ON ertelmifogyatekos.ID = tanulo.C_ERTELMIFOGYATEKOS AND ertelmifogyatekos.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND ertelmifogyatekos.C_TANEVID = tanulo.C_ALTANEVID AND ertelmifogyatekos.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES latasserult ON latasserult.ID = tanulo.C_LATASSERULT AND latasserult.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND latasserult.C_TANEVID = tanulo.C_ALTANEVID AND latasserult.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES hallasserult ON hallasserult.ID = tanulo.C_HALLASSERULT AND hallasserult.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND hallasserult.C_TANEVID = tanulo.C_ALTANEVID AND hallasserult.TOROLT = 'F'
  LEFT JOIN T_DICTIONARYITEMBASE_OSSZES hatranyoshelyzet ON hatranyoshelyzet.ID = tanulo.C_HATRANYOSHELYZETU AND hatranyoshelyzet.C_INTEZMENYID = tanulo.C_ALINTEZMENYID AND hatranyoshelyzet.C_TANEVID = tanulo.C_ALTANEVID AND hatranyoshelyzet.TOROLT = 'F'
WHERE tanulo.TOROLT = 'F'
  AND tanulo.C_ALTANEVID = @pTanevId
  
END
GO

