DROP PROCEDURE IF EXISTS uspGetAlkalmazottMunkaugyiAdatokData
GO

CREATE PROCEDURE uspGetAlkalmazottMunkaugyiAdatokData
  @pTanevId int

AS 
BEGIN
  SET NOCOUNT ON;

  SELECT
     a.ID AS ID
    ,a.C_FOALLAS AS Foallasu
    ,a.C_SZAKERTOIVIZSGAELNOKI AS SzakertoiVagyVizsgaelnokiTevekenysegu
    ,a.C_TOVABBKEPZES AS SzakmaiTovabbkepzes
    ,a.C_SZAKVIZSGA AS Szakvizsga
    ,a.C_ALLANDOHELYETTESITESRE AS TartosHelyettesites 
    ,ma.ID AS MunkaugyiAdatId
    ,ma.C_BESOROLASIFOKOZAT AS BesorolasiFokozat
    ,ma.C_MUNKAKORTIPUSA AS Munkakor
    ,ma.C_MUNKAVISZONYTIPUSA AS FoglalkoztatasModja
    ,ma.C_FOGLALKOZTATASTIPUS AS FoglalkoztatasTipusa
    ,ma.C_KOTELEZOORASZAM AS KotelezoOraszama
    ,ma.C_MUNKAIDOKEDVEZMENYORASZAM AS MunkaidoKedvezmenyOraszama
    ,ma.C_VEZETOIORASZAMOK AS VezetoiOraszamOka
    ,ma.C_MUNKAIDOKEDVEZMENYOKA AS MunkaidoKedvezmenyOka
    ,ma.C_ALKALMAZASKEZDETE AS AlkalmazasKezdete
    ,ma.C_TARTOSHELYETTESITES AS TartosTavollet
    ,ma.C_BETOLTETLENALLASHELY AS BetoltetlenAllashely
    ,ma.C_ISKULSOALKALMAZOTT AS IsKulsoAlkalmazott
    ,ma.C_ISSZAKERTOKUTATOTANAR AS IsSzakertoKutatotanar
    ,ma.C_SZAKERTOMESTERPEDAGOGUS AS SzakertoMesterpedagogus
    ,ma.C_NYUGDIJAS AS Nyugdijas
    ,ma.C_ATTANITO AS Attanito
    ,ma.C_ATTANITOMASINTEZMENYNEL AS AttanitoMasIntezmenynel
    ,ma.C_IMPORTALT AS Importalt
    ,fh.ID AS FelhasznaloId
    ,fh.C_NEVSORREND AS FelhasznaloNevsorrend
    ,fh.C_ELOTAG AS FelhasznaloElotag
    ,fh.C_VEZETEKNEV AS FelhasznaloVezeteknev
    ,fh.C_UTONEV AS FelhasznaloKeresztnev
    ,fh.C_SZULETESIHELY AS FelhasznaloSzuletesiHely
    ,fh.C_SZULETESIDATUM AS FelhasznaloSzuletesiIdo
    ,fh.C_ANYJANEVESORREND AS AnyjaNeveNevsorrend
    ,fh.C_ANYJANEVEELOTAG AS AnyjaNeveElotag
    ,fh.C_ANYJAVEZETEKNEVE AS AnyjaVezetekneve
    ,fh.C_ANYJAUTONEVE AS AnyjaUtoneve
    ,fh.C_OKTATASIAZONOSITO AS FelhasznaloOktatasiAzonosito
    ,fh.C_ADOAZONOSITOJEL AS AdoazonositoJel
    ,fe.C_OKTATASINEVELESIFELADATTIPUS AS OktatasiNevelesiFeladatTipusId
    ,mh.C_NEV AS MukodesiHelyNev
  FROM T_MUNKAUGYIADATOK_OSSZES ma
    INNER JOIN T_FELHASZNALO_OSSZES fh ON fh.ID = ma.C_ALKALMAZOTTID AND fh.C_TANEVID = ma.C_TANEVID AND fh.TOROLT = 'F'
    INNER JOIN T_ALKALMAZOTT_OSSZES a ON a.ID = ma.C_ALKALMAZOTTID AND a.C_ALTANEVID = ma.C_TANEVID AND a.TOROLT = 'F'
    INNER JOIN T_FELADATELLATASIHELY_OSSZES fe ON fe.ID = ma.C_FELADATELLATASIHELYID AND fe.C_TANEVID = ma.C_TANEVID AND fe.TOROLT = 'F'
    INNER JOIN T_MUKODESIHELY_OSSZES mh ON mh.ID = fe.C_MUKODESIHELYID AND mh.C_TANEVID = ma.C_TANEVID AND mh.TOROLT = 'F'
  WHERE ma.C_TANEVID = @pTanevId
    AND ma.TOROLT = 'F'
  ORDER BY IIF(fh.C_NEVSORREND = 'T', fh.C_UTONEV + ' ' + fh.C_VEZETEKNEV, fh.C_VEZETEKNEV + ' ' + fh.C_UTONEV)

END

GO
