DROP PROCEDURE IF EXISTS uspGetCovidBejelentett
GO

CREATE PROCEDURE uspGetCovidBejelentett
   @pTanevId int

AS BEGIN

-- Gondviselo ltal bejelentett esetek
  SELECT
     g.C_NEV AS 'GondviseloNev'
    ,f.C_NYOMTATASINEV AS 'TanuloNev'
    ,f.C_OKTATASIAZONOSITO AS 'TanuloOktatasiAzonosito'
    ,g.C_COVIDBEJELENTESDATUMA AS 'BejelentesDatuma'
  FROM T_GONDVISELO g
    INNER JOIN T_TANULO t ON t.ID = g.C_TANULOID AND t.TOROLT = 'F'
    INNER JOIN T_FELHASZNALO f ON f.ID = t.ID AND f.TOROLT = 'F'
  WHERE g.TOROLT = 'F'
    AND g.C_TANEVID = @pTanevId
    AND g.C_ISCOVIDBEJELENTO = 'T'
    AND DATEADD(DAY, 14, CONVERT(date, g.C_COVIDBEJELENTESDATUMA)) >= CONVERT(date, GETDATE())
  ORDER BY GondviseloNev, TanuloNev, TanuloOktatasiAzonosito

END
GO