DROP PROCEDURE IF EXISTS uspGetCsengetesiRendek
GO
  CREATE PROCEDURE uspGetCsengetesiRendek
     @pOsztalyCsoportId INT
    ,@pIntezmenyId INT
		,@pTanevId INT
    ,@pKezdoDatum DATETIME
    ,@pVegDatum DATETIME
  AS
  BEGIN
    SET NOCOUNT ON;

    SELECT DISTINCT NAPTARINAP.C_NAPDATUMA Datum
      ,NAPTARINAP.C_HETNAPJA Hetnapja
      ,trend.CsengetesiRendId CsengetesiRendId
      ,trend.C_ORARENDINAP OrarendiNap
      ,trend.C_NAPTIPUSA TanevRendTipus
      ,trend.C_OSSZESCSOPORTRAVONATKOZIK AS IsOsszesCsoport
      ,ocstr.C_OSZTALYCSOPORTID AS OsztalyCsoportId
      ,ocs.C_NEV OsztalyCsoportNev
    FROM (
      SELECT C_NAPDATUMA
        ,C_HETNAPJA
      FROM T_NAPTARINAP_OSSZES
      WHERE TOROLT = 'F'
        AND C_NAPDATUMA BETWEEN @pKezdoDatum
          AND @pVegDatum
        AND C_TANEVID = @pTanevId
        AND C_INTEZMENYID = @pIntezmenyId
      ) NAPTARINAP
    LEFT JOIN (
      SELECT T_TANEVRENDJE_OSSZES.C_DATUM Datum
        ,T_TANEVRENDJE_OSSZES.C_NAPTIPUSA
        ,T_TANEVRENDJE_OSSZES.C_ORARENDINAP
        ,T_TANEVRENDJE_OSSZES.C_CSENGETESIRENDID CsengetesiRendId
        ,T_TANEVRENDJE_OSSZES.C_OSSZESCSOPORTRAVONATKOZIK
        ,T_TANEVRENDJE_OSSZES.ID
      FROM T_TANEVRENDJE_OSSZES
      LEFT JOIN (
        SELECT *
        FROM T_OSZTALYCSOPORT_TANEVRENDJE
        ) ocst ON T_TANEVRENDJE_OSSZES.Id = ocst.C_TANEVRENDJEID
      WHERE T_TANEVRENDJE_OSSZES.TOROLT = 'F'
        AND T_TANEVRENDJE_OSSZES.C_DATUM BETWEEN @pKezdoDatum
          AND @pVegDatum
        AND (
          (
            C_OSZTALYCSOPORTID = @pOsztalyCsoportId
            OR @pOsztalyCsoportId IS NULL
            )
          OR C_OSSZESCSOPORTRAVONATKOZIK = 'T'
          )
        AND T_TANEVRENDJE_OSSZES.C_TANEVID = @pTanevId
        AND T_TANEVRENDJE_OSSZES.C_INTEZMENYID = @pIntezmenyId
      ) trend ON trend.Datum = NAPTARINAP.C_NAPDATUMA
    LEFT JOIN T_OSZTALYCSOPORT_TANEVRENDJE ocstr ON ocstr.C_TANEVRENDJEID = trend.ID
    LEFT JOIN T_OSZTALYCSOPORT_OSSZES ocs ON ocs.ID = ocstr.C_OSZTALYCSOPORTID
      AND ocs.TOROLT = 'F'
    WHERE trend.C_NAPTIPUSA IS NOT NULL
  END
GO


