﻿DROP PROCEDURE IF EXISTS uspGetFelhasznalokTanevekByFelhasznaloId
GO

CREATE PROCEDURE uspGetFelhasznalokTanevekByFelhasznaloId
   @pFelhasznaloId int
AS
BEGIN
  SET NOCOUNT ON;

  SELECT 
     fh.ID as FelhasznaloId
    ,fh.C_NYOMTATASINEV as FelhasznaloNev
    ,fh.C_EGYEDIAZONOSITO FelhasznaloEgyediAzonosito
    ,tanev.ID as TanevId
    ,tanev.C_AKTIV as TanevIsActiv
    ,tanev.C_KOVETKEZO as TanevIsKovetkezo
    ,tanev.C_NEV as TanevNev
  FROM T_FELHASZNALO_OSSZES fh
    INNER JOIN T_TANEV_OSSZES tanev ON tanev.ID = fh.C_TANEVID 
      AND tanev.TOROLT = 'F' 
      AND tanev.C_ISKIVALASZTHATO = 'T'
    INNER JOIN T_FELHASZNALO_OSSZES fh2 ON fh2.ID = @pFelhasznaloId
      AND (fh2.C_OKTATASIAZONOSITO = fh.C_OKTATASIAZONOSITO OR fh2.ID = fh.ID) 
  WHERE fh.TOROLT = 'F'

END
GO
