DROP PROCEDURE IF EXISTS uspGetHelyettesitesekListaja
GO

CREATE PROCEDURE uspGetHelyettesitesekListaja
   @pKezdoDatum datetime = NULL
  ,@pVegDatum datetime = NULL
  ,@pHelyettesitesTipusId int = NULL
  ,@pHelyettesitettId int = NULL
  ,@pHelyettesitoId int = NULL
  ,@pIsNaplozott char(1) = NULL
  ,@pOsztalyCsoportId int = NULL
  ,@pTantargyId int = NULL
  ,@pKellKapcsolodoCsoportok char = 'F'
  ,@pTanevID int
  ,@pFeladatKategoriaId int = NULL
  ,@pFeladatEllatasiHelyId int = NULL
  ,@pIsOnlineOra bit = NULL
AS
BEGIN
  SET NOCOUNT ON
  DECLARE
     @sql nvarchar(max)=N''
    ,@whereString nvarchar(max) = ''

    SET @sql+=N'
  CREATE TABLE #NaptariNap (
     Datum datetime
    ,OsztalyCsoportId int
    ,IsTanitasiNap char(1)
    ,PRIMARY KEY (Datum, OsztalyCsoportId, IsTanitasiNap)
  )
  DECLARE @DateFrom datetime, @DateTo datetime
  SELECT @DateFrom = ISNULL(@pKezdoDatum,tv.C_KEZDONAP), @DateTo = ISNULL(@pVegDatum,tv.C_UTOLSONAP) FROM T_TANEV tv WHERE tv.ID = @pTanevID
  INSERT INTO #NaptariNap
  SELECT
     tr.Datum
    ,tr.OsztalyId
    ,ISNULL(tro.IsTanitasiNap, tr.IsTanitasiNap) AS IsTanitasiNap
  FROM (
    SELECT
       nn.C_NAPDATUMA AS Datum
      ,ocs.ID AS OsztalyId
      ,nn.C_ORARENDINAP AS IsTanitasiNap
    FROM T_NAPTARINAP_OSSZES nn
      INNER JOIN T_OSZTALYCSOPORT_OSSZES ocs ON ocs.C_TANEVID = @pTanevID
    WHERE nn.C_NAPDATUMA BETWEEN @DateFrom AND @DateTo AND nn.C_TANEVID = @pTanevID
      AND nn.TOROLT = ''F''
  ) tr
  LEFT JOIN (
    SELECT
       nn.C_NAPDATUMA AS Datum
      ,ocstr.C_OSZTALYCSOPORTID AS OsztalyId
      ,tr.C_ORARENDINAP AS IsTanitasiNap
    FROM T_NAPTARINAP_OSSZES nn
      INNER JOIN T_TANEVRENDJE_OSSZES tr ON tr.C_DATUM = nn.C_NAPDATUMA AND tr.C_OSSZESCSOPORTRAVONATKOZIK = ''F'' AND tr.TOROLT = ''F''
      INNER JOIN T_OSZTALYCSOPORT_TANEVRENDJE ocstr ON ocstr.C_TANEVRENDJEID = tr.ID
      INNER JOIN T_OSZTALYCSOPORT_OSSZES ocs ON ocs.ID = ocstr.C_OSZTALYCSOPORTID
      INNER JOIN T_NAPTIPUS_OSSZES nt ON nt.ID = tr.C_NAPTIPUSA AND nt.C_ALTANEVID = tr.C_TANEVID AND nt.TOROLT = ''F''
    WHERE nn.C_TANEVID = @pTanevID
      AND nn.TOROLT = ''F''
  ) tro ON tr.Datum = tro.Datum AND tr.OsztalyId = tro.OsztalyId
  WHERE EXISTS (SELECT TOP 1 1 FROM T_HELYETTESITESIIDOSZAK_OSSZES WHERE TOROLT=''F'' AND C_HELYETTESITESNAPJA = tr.Datum AND C_TANEVID = @pTanevID)
    AND ISNULL(tro.IsTanitasiNap, tr.IsTanitasiNap) = ''T'''
  
  IF @pKezdoDatum IS NOT NULL BEGIN
    SET @whereString += N'
      AND hisz.HelyettesitesDatum >= @pKezdoDatum'
  END

  IF @pVegDatum IS NOT NULL BEGIN
    SET @whereString += N'
      AND hisz.HelyettesitesDatum <= @pVegDatum'
  END

  IF @pHelyettesitesTipusId IS NOT NULL BEGIN
    SET @whereString += N'
      AND hisz.HelyettesitesTipusId = @pHelyettesitesTipusId'
  END
  ELSE BEGIN
    SET @whereString += N'
      AND hisz.HelyettesitesTipusId IS NOT NULL'
  END

  IF @pHelyettesitettId IS NOT NULL BEGIN
    SET @whereString += N'
      AND hisz.HelyettesitettId = @pHelyettesitettId'
  END

  IF @pHelyettesitoId IS NOT NULL BEGIN
    SET @whereString += N'
      AND hisz.HelyettesitoId = @pHelyettesitoId'
  END

  IF @pOsztalyCsoportId IS NOT NULL BEGIN
     IF(@pKellKapcsolodoCsoportok = 'T')
    BEGIN
      SET @whereString += N'
        AND hisz.OsztalyCsoportId IN  (SELECT ID  FROM  fnGetKapcsolodoOsztalycsoportok(@pOsztalyCsoportId))'
    END
  ELSE
    BEGIN
      SET @whereString += N'
        AND hisz.OsztalyCsoportId = @pOsztalyCsoportId'
    END
  END

  IF @pTantargyId IS NOT NULL BEGIN
    SET @whereString += N'
      AND hisz.TantargyId = @pTantargyId'
  END

  IF @pIsNaplozott = 0 BEGIN
    SET @whereString+=N'
      AND hisz.Naplozott = ''F'''
    END
  ELSE IF @pIsNaplozott = 1 BEGIN
    SET @whereString += N'
      AND hisz.Naplozott = ''T'''
    END
  ELSE BEGIN
    SET @whereString += N'
      AND hisz.Naplozott IS NOT NULL'
  END

  SET @whereString += IIF(@pIsOnlineOra IS NOT NULL, N'
    AND hisz.IsOnlineOra = ' + IIF(@pIsOnlineOra = 1, '''T''', '''F'''), '')

SET @sql += N'
SELECT
   HelyettesitesDatum
  ,Ora
  ,Helyettesitett
  ,HelyettesitettElotagNelkul
  ,HelyettesitettId
  ,HelyettesitesTipusId
  ,HelyettesitesOka
  ,C_MEGJEGYZES    AS Megjegyzes
  ,Helyettesito
  ,HelyettesitoElotagNelkul
  ,HelyettesitoId
  ,OsztalyCsoport
  ,OsztalyCsoportId
  ,Tantargy
  ,TantargyId
  ,Naplozott
  ,ID
  ,IsOnlineOra
FROM(
SELECT
   hisz.C_HELYETTESITESNAPJA AS HelyettesitesDatum
  ,oo.C_ORASZAM AS Ora
  ,helyettesitett.C_NYOMTATASINEV AS Helyettesitett
  ,IIF(helyettesitett.C_NEVSORREND = ''T'',
          helyettesitett.C_UTONEV + '' '' + helyettesitett.C_VEZETEKNEV,
          helyettesitett.C_VEZETEKNEV + '' '' + helyettesitett.C_UTONEV) AS HelyettesitettElotagNelkul
  ,helyettesitett.ID AS HelyettesitettId
  ,hisz.C_HELYETTESITESTIPUS AS HelyettesitesTipusId
  ,hisz.C_HELYETTESITESOKA AS HelyettesitesOka
  ,'''' as C_MEGJEGYZES
  ,helyettesito.C_NYOMTATASINEV AS Helyettesito
  ,IIF(helyettesito.C_NEVSORREND = ''T'',
          helyettesito.C_UTONEV + '' '' + helyettesito.C_VEZETEKNEV,
          helyettesito.C_VEZETEKNEV + '' '' + helyettesito.C_UTONEV) AS HelyettesitoElotagNelkul
  ,helyettesito.ID AS HelyettesitoId
  ,ocs.C_NEV AS OsztalyCsoport
  ,ocs.ID AS OsztalyCsoportId
  ,tantargy.C_NEV AS Tantargy
  ,tantargy.ID AS TantargyId
  ,''F'' AS Naplozott
  ,hisz.ID as ID
  ,ISNULL(ootOnlineOra.C_BOOLERTEK, ottOnlineOra.C_BOOLDEFAULT) AS IsOnlineOra
FROM T_HELYETTESITESIIDOSZAK hisz
  INNER JOIN T_ORARENDIORA oo ON oo.ID=hisz.C_HELYETTESITETTORARENDID
  INNER JOIN T_TANTARGY tgy ON tgy.ID=oo.C_TANTARGYID
  INNER JOIN T_FELHASZNALO helyettesitett ON oo.C_TANARID = helyettesitett.ID
  INNER JOIN T_FELHASZNALO helyettesito ON hisz.C_HELYETTESTANAROKID= helyettesito.ID
  INNER JOIN T_OSZTALYCSOPORT ocs ON oo.C_OSZTALYCSOPORTID = ocs.ID AND (ocs.C_FELADATKATEGORIAID = @pFeladatKategoriaId OR @pFeladatKategoriaId IS NULL)AND (ocs.C_FELADATELLATASIHELYID = @pFeladatEllatasiHelyId OR @pFeladatEllatasiHelyId IS NULL)
  INNER JOIN T_TANTARGY tantargy ON oo.C_TANTARGYID = tantargy.ID
  INNER JOIN #NaptariNap nn ON nn.OsztalyCsoportId = oo.C_OSZTALYCSOPORTID AND nn.Datum = hisz.C_HELYETTESITESNAPJA
  INNER JOIN T_ORATULAJDONSAGTIPUS_OSSZES ottOnlineOra ON ottOnlineOra.TOROLT = ''F'' AND ottOnlineOra.C_ALTANEVID = oo.C_TANEVID AND ottOnlineOra.ID = 8615
  LEFT JOIN T_ORARENDIORATULAJDONSAG_OSSZES ootOnlineOra ON ootOnlineOra.C_ORATULAJDONSAGID = ottOnlineOra.ID AND ootOnlineOra.C_TANEVID = ottOnlineOra.C_ALTANEVID AND ootOnlineOra.TOROLT = ''F'' AND ootOnlineOra.C_ORARENDIORAID = oo.ID
  WHERE NOT EXISTS(
  SELECT 1 FROM T_TANITASIORA tao WHERE tao.C_DATUM=hisz.C_HELYETTESITESNAPJA AND tao.C_OSZTALYCSOPORTID=oo.C_OSZTALYCSOPORTID
          AND tao.C_TANTARGYID=oo.C_TANTARGYID AND (tao.C_TANARID = hisz.C_HELYETTESTANAROKID OR tao.C_HELYETTESITOTANARID = hisz.C_HELYETTESTANAROKID) AND tao.C_HELYETTESITESTIPUSA IS NOT NULL
          AND (oo.C_ORASZAM=tao.C_ORASZAM OR (oo.C_ORASZAM IS NULL AND tao.C_ORAKEZDETE=tao.C_DATUM+oo.C_ORAKEZDETE AND tao.C_ORAVEGE=tao.C_DATUM+oo.C_ORAVEGE)))
UNION ALL
SELECT
   tao.C_DATUM AS HelyettesitesDatum
  ,tao.C_ORASZAM AS Ora
  ,helyettesitett.C_NYOMTATASINEV AS Helyettesitett
  ,IIF(helyettesitett.C_NEVSORREND = ''T'',
          helyettesitett.C_UTONEV + '' '' + helyettesitett.C_VEZETEKNEV,
          helyettesitett.C_VEZETEKNEV + '' '' + helyettesitett.C_UTONEV) AS HelyettesitettElotagNelkul
  ,helyettesitett.ID AS HelyettesitettId
  ,tao.C_HELYETTESITESTIPUSA AS HelyettesitesTipusId
  ,tao.C_HELYETTESITESOKA AS HelyettesitesOka
  ,tao.C_MEGJEGYZES as C_MEGJEGYZES
  ,helyettesito.C_NYOMTATASINEV AS Helyettesito
  ,IIF(helyettesito.C_NEVSORREND = ''T'',
          helyettesito.C_UTONEV + '' '' + helyettesito.C_VEZETEKNEV,
          helyettesito.C_VEZETEKNEV + '' '' + helyettesito.C_UTONEV) AS HelyettesitoElotagNelkul
  ,helyettesito.ID AS HelyettesitoId
  ,ocs.C_NEV AS OsztalyCsoport
  ,ocs.ID AS OsztalyCsoportId
  ,tantargy.C_NEV AS Tantargy
  ,tantargy.ID AS TantargyId
  ,''T'' AS Naplozott
  ,tao.ID
  ,ISNULL(totOnlineOra.C_BOOLERTEK, ottOnlineOra.C_BOOLDEFAULT) AS IsOnlineOra
FROM T_TANITASIORA tao
  INNER JOIN T_TANTARGY tgy ON tgy.ID=tao.C_TANTARGYID
  INNER JOIN T_FELHASZNALO helyettesitett ON tao.C_TANARID= helyettesitett.ID
  INNER JOIN T_FELHASZNALO helyettesito ON tao.C_HELYETTESITOTANARID= helyettesito.ID
  INNER JOIN T_OSZTALYCSOPORT ocs ON tao.C_OSZTALYCSOPORTID = ocs.ID
  INNER JOIN T_TANTARGY tantargy ON tao.C_TANTARGYID = tantargy.ID
  INNER JOIN T_ORATULAJDONSAGTIPUS_OSSZES ottOnlineOra ON ottOnlineOra.TOROLT = ''F'' AND ottOnlineOra.C_ALTANEVID = tao.C_TANEVID AND ottOnlineOra.ID = 8615
  LEFT JOIN T_TANITASIORATULAJDONSAG_OSSZES totOnlineOra ON totOnlineOra.C_ORATULAJDONSAGID = ottOnlineOra.ID AND totOnlineOra.C_TANEVID = ottOnlineOra.C_ALTANEVID AND totOnlineOra.TOROLT = ''F'' AND totOnlineOra.C_TANITASIORAID = tao.ID
WHERE C_HELYETTESITESTIPUSA IS NOT NULL AND tao.TOROLT=''F''
) hisz WHERE (1=1)
' +@whereString

  EXEC sp_executesql @sql, N'
     @pKezdoDatum datetime
    ,@pVegDatum datetime
    ,@pHelyettesitesTipusId int
    ,@pHelyettesitettId int
    ,@pHelyettesitoId int
    ,@pIsNaplozott char(1)
    ,@pOsztalyCsoportId int
    ,@pTantargyId int
    ,@pFeladatKategoriaId int
    ,@pFeladatEllatasiHelyId int
    ,@pTanevID int'
    ,@pKezdoDatum = @pKezdoDatum
    ,@pVegDatum = @pVegDatum
    ,@pHelyettesitesTipusId = @pHelyettesitesTipusId
    ,@pHelyettesitettId = @pHelyettesitettId
    ,@pHelyettesitoId = @pHelyettesitoId
    ,@pIsNaplozott = @pIsNaplozott
    ,@pOsztalyCsoportId = @pOsztalyCsoportId
    ,@pTantargyId = @pTantargyId
    ,@pFeladatKategoriaId = @pFeladatKategoriaId
    ,@pFeladatEllatasiHelyId = @pFeladatEllatasiHelyId
    ,@pTanevID = @pTanevID
END
GO