DROP PROCEDURE IF EXISTS uspGetIktatottDokumentumKulcsszavak
GO

CREATE PROCEDURE dbo.uspGetIktatottDokumentumKulcsszavak
  @pIntezmenyId INT,
  @pTanevId INT,
  @pIktatottDokumentumId INT
AS
BEGIN
  SET NOCOUNT ON;

  DECLARE @dokumentumTipus int = (SELECT C_DOKUMENTUMTIPUS FROM T_IKTATOTTDOKUMENTUM_OSSZES WHERE ID = @pIktatottDokumentumId)
  SELECT 
    ksz.C_DOKUMENTUMKULCSSZOTIPUS tipus, ertek =  
    CASE 
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7399 THEN (SELECT C_NEV FROM T_OSZTALYCSOPORT_OSSZES WHERE ID = ksze.C_ERTEK)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7400 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7401 THEN 
        CASE 
        -- Ahol mkdsi hely van megadva feladatelltsi helynek
          WHEN @dokumentumTipus IN (7430) THEN
            (SELECT mh.C_NEV FROM T_MUKODESIHELY_OSSZES mh
              WHERE mh.C_INTEZMENYID=@pIntezmenyId 
                AND mh.TOROLT = 'F' 
                AND mh.ID = ksze.C_ERTEK
            )
        -- feladatelltsi hely van megadva
          ELSE
            (SELECT mh.C_NEV FROM T_MUKODESIHELY_OSSZES mh
              INNER JOIN T_FELADATELLATASIHELY_OSSZES feh ON feh.C_MUKODESIHELYID = mh.ID 
                AND mh.C_TANEVID=feh.C_TANEVID
                AND feh.TOROLT = 'F'
              WHERE mh.C_INTEZMENYID=@pIntezmenyId 
                AND feh.ID = ksze.C_ERTEK
                AND mh.TOROLT = 'F'
            )
        END
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7402 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7403 THEN (SELECT C_NYOMTATASINEV FROM T_FELHASZNALO WHERE ID = ksze.C_ERTEK)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7404 THEN (SELECT C_NEV FROM T_TANTERV_OSSZES WHERE ID = ksze.C_ERTEK)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7405 THEN ksze.C_ERTEK
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7406 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7407 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7408 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7409 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7410 THEN (SELECT C_NEV FROM T_OSZTALYCSOPORT_OSSZES WHERE ID = ksze.C_ERTEK)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7411 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7412 THEN (SELECT C_NYOMTATASINEV FROM T_FELHASZNALO_OSSZES WHERE ID = ksze.C_ERTEK)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7413 THEN ksze.C_ERTEK
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7414 THEN ksze.C_ERTEK
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7415 THEN (SELECT C_NYOMTATASINEV FROM T_FELHASZNALO_OSSZES WHERE ID = ksze.C_ERTEK)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7416 THEN ksze.C_ERTEK
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7417 THEN ksze.C_ERTEK
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7418 THEN ksze.C_ERTEK
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7419 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7420 THEN (SELECT C_NYOMTATASINEV FROM T_FELHASZNALO_OSSZES WHERE ID = ksze.C_ERTEK)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7561 THEN ksze.C_ERTEK
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7562 THEN ksze.C_ERTEK
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7674 THEN (SELECT C_NEV FROM T_TEREM_OSSZES WHERE ID = ksze.C_ERTEK)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 8620 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 8621 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7810 THEN (SELECT  dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7811 THEN ksze.C_ERTEK
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7812 THEN (SELECT C_NYOMTATASINEV FROM T_FELHASZNALO_OSSZES WHERE ID = ksze.C_ERTEK)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7813 THEN (SELECT C_NYOMTATASINEV FROM T_FELHASZNALO_OSSZES WHERE ID = ksze.C_ERTEK)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 7814 THEN ksze.C_ERTEK
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 8696 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 8697 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 8698 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 8699 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 8700 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      WHEN ksz.C_DOKUMENTUMKULCSSZOTIPUS = 8701 THEN (SELECT dti.C_NAME FROM T_DICTIONARYITEMBASE_OSSZES dti WHERE id = ksze.C_ERTEK AND dti.C_INTEZMENYID=@pIntezmenyId AND dti.C_TANEVID=@pTanevId)
      ELSE CONCAT('*', ksze.C_ERTEK)
    END
  FROM T_DOKUMENTUMKULCSSZO_OSSZES ksz
    INNER JOIN T_DOKUMENTUMKULCSSZOERTEK_OSSZES ksze ON ksz.C_DOKUMENTUMKULCSSZOERTEKID = ksze.ID
    INNER JOIN T_DICTIONARYITEMBASE_OSSZES d ON d.ID = ksz.C_DOKUMENTUMKULCSSZOTIPUS AND d.C_TANEVID = ksz.C_TANEVID
    WHERE ksz.C_IKTATOTTDOKUMENTUMID = @pIktatottDokumentumId
  ORDER BY d.C_ORDER

END

GO
