DROP PROCEDURE IF EXISTS uspGetNemKotottMunkaIdoByGroupId
GO

CREATE PROCEDURE uspGetNemKotottMunkaIdoByGroupId
   @IntezmenyId int
  ,@TanevId int
  ,@IdoszakKezdete datetime
  ,@IdoszakVege datetime
  ,@GroupId uniqueidentifier
AS
BEGIN
  SET NOCOUNT ON;

  SELECT
    nkm.ID as Id
    ,nkm.C_GROUPID as GroupID
    ,nkm.C_KEZDETE as Kezdete
    ,nkm.C_MEGJEGYZES as Megjegyzes
    ,nkm.C_NAPLOZOTTMEGJEGYZES as NaplozottMegjegyzes
    ,nkm.C_MEGTARTOTT as Megtartott
    ,nkm.C_TEVEKENYSEGTIPUSA as TorvenyKategoriaID
    ,nkm.C_VEGE as Vege
    ,nkm.C_TANARID as TanarID
    ,nkm.C_TULAJDONOSID as TulajdonosID
    ,nkm.TOROLT as Torolt
    ,nkm.C_ISTANARALTALTOROLT as TanarAltalTorolt
  FROM T_NEMKOTOTTMUNKAIDO_OSSZES nkm
  WHERE
    nkm.TOROLT = 'F'
    AND nkm.C_INTEZMENYID = @IntezmenyId
    AND nkm.C_TANEVID = @TanevId
    AND @IdoszakKezdete <= C_KEZDETE AND @IdoszakVege >= C_VEGE
    AND nkm.C_GROUPID = @GroupId
END
GO