DROP PROCEDURE IF EXISTS uspGetSapAdattisztasagExcel
GO

CREATE PROCEDURE uspGetSapAdattisztasagExcel

AS BEGIN
  SET NOCOUNT ON;

  SELECT UPPER(f.C_NYOMTATASINEV) AS fNyomtatasiNev
        ,UPPER(s.Nev) AS sNyomtatasiNev
        ,CAST(f.C_SZULETESIDATUM AS DATE) AS fSzuletesiDatum
        ,CAST(s.[Születési dátum] AS DATE) AS sSzuletesiDatum
        ,LEFT(UPPER(f.C_SZULETESIHELY),IIF(CHARINDEX(' ',f.C_SZULETESIHELY) > 0,CHARINDEX(' ',f.C_SZULETESIHELY), DATALENGTH(f.C_SZULETESIHELY))) AS fSzuletesiHely
        ,LEFT(UPPER(s.[Születési hely]),IIF(CHARINDEX(' ',s.[Születési hely]) > 0,CHARINDEX(' ',s.[Születési hely]), DATALENGTH(s.[Születési hely]))) AS sSzuletesiHely
        ,UPPER(f.C_ANYJANEVE) AS fAnyjaNeve
        ,UPPER(ISNULL(s.[Anyja vezetékneve],'') + ISNULL(' '+s.[Anyja keresztneve],'') + ISNULL(' '+s.[Anyja keresztneve2],'') ) AS sAnyjaNeve
  FROM T_FELHASZNALO_OSSZES f
  INNER JOIN dev.SAPTorzsadatokTisztitas s on s.KretaAzonosito = f.ID
  INNER JOIN T_TANEV_OSSZES t ON t.ID = f.C_TANEVID AND t.C_AKTIV = 'T' AND t.TOROLT = 'F'
  WHERE f.TOROLT = 'F'
    AND NOT EXISTS (SELECT 1
                    FROM dev.SAPTorzsadatokTisztitas s
                    WHERE s.KretaAzonosito = f.ID
                    AND UPPER(REPLACE(REPLACE(REPLACE(ISNULL(s.Nev,''), ' ', ''),'.',''),'-','')) = UPPER(REPLACE(REPLACE(REPLACE(ISNULL(f.C_NYOMTATASINEV,''), ' ', ''),'.',''),'-',''))
                    AND CAST(s.[Születési dátum] AS DATE) = CAST(f.C_SZULETESIDATUM AS DATE)
                    AND LEFT(UPPER(s.[Születési hely]),IIF(CHARINDEX(' ',s.[Születési hely]) > 0,CHARINDEX(' ',s.[Születési hely]), DATALENGTH(s.[Születési hely]))) = LEFT(UPPER(f.C_SZULETESIHELY),IIF(CHARINDEX(' ',f.C_SZULETESIHELY) > 0,CHARINDEX(' ',f.C_SZULETESIHELY), DATALENGTH(f.C_SZULETESIHELY)))
                    AND UPPER(REPLACE(REPLACE(REPLACE((ISNULL(s.[Anyja vezetékneve], '') + ISNULL(s.[Anyja keresztneve], '') + ISNULL(s.[Anyja keresztneve2],'')), ' ', ''),'.',''),'-','')) = UPPER(REPLACE(REPLACE(REPLACE(ISNULL(f.C_ANYJANEVE,''), ' ', ''),'.',''),'-','')))

END

GO
