﻿DROP PROCEDURE IF EXISTS uspGetTanorakGridForNaplozasData
GO

CREATE PROCEDURE uspGetTanorakGridForNaplozasData
   @pOsztalyCsoportId int
  ,@pTantargyId int
  ,@pTanevId int
AS BEGIN
SET NOCOUNT ON;

SELECT
   tora.ID
  ,tora.C_DATUM AS Datum
  ,tora.C_BEJEGYZESIDEJE AS NaplozasDatuma
  ,tora.C_OSZTALYCSOPORTID AS OsztCsop
  ,ocs.C_NEV AS OsztCsopNev
  ,tora.C_TANTARGYID AS Targy
  ,tgy.C_NEV AS TargyNev
  ,tora.C_TANARID AS Tanar
  ,tora.C_HELYETTESITOTANARID AS HTanar
  ,otf.C_NYOMTATASINEV AS TanarNev
  ,IIF(tora.C_HELYETTESITOTANARID IS NULL, 'F', 'T') AS IsHelyetesitett
  ,CAST(tora.C_ORASZAM AS nvarchar) AS OraSorsz
  ,IIF(tora.C_MEGTARTOTT = 'T', tora.C_TEMA, N'Elmaradt óra') AS Tema
  ,tora.C_HETNAPJA AS HetNapja
  ,tora.C_EGYEDINAP as IsEgyediNap
  ,tora.C_ORAKEZDETE AS OraKezdete
  ,IIF(tora.C_MEGTARTOTT = 'T', CAST(tora.C_ORAEVESSORSZAMA AS nvarchar(20)), N'Elmaradt óra') AS EvesSorsz
FROM T_TANITASIORA_OSSZES tora
  LEFT JOIN T_OSZTALYCSOPORT_OSSZES ocs on ocs.ID = tora.C_OSZTALYCSOPORTID AND ocs.TOROLT = 'F'
  LEFT JOIN T_TANTARGY_OSSZES tgy on tgy.ID = tora.C_TANTARGYID AND tgy.TOROLT = 'F'
  LEFT JOIN T_FELHASZNALO_OSSZES otf ON otf.ID = ISNULL(tora.C_HELYETTESITOTANARID, tora.C_TANARID) AND otf.TOROLT = 'F'
WHERE tora.TOROLT = 'F'
  AND tora.C_OSZTALYCSOPORTID = @pOsztalyCsoportId
  AND tora.C_TANTARGYID = @pTantargyId
  AND tora.C_TANEVID = @pTanevId

END
GO