﻿DROP PROCEDURE IF EXISTS dbo.uspGetVezetettOsztalyCsoportokByAlkalmazott
GO

CREATE PROCEDURE dbo.uspGetVezetettOsztalyCsoportokByAlkalmazott
   @pAlkalmazottId int
  ,@pTanevID int
AS
BEGIN
  SET NOCOUNT ON;
  SELECT 
     ocs.ID as OsztalyCsoportId
    ,ocs.C_NEV as OsztalyCsoportNev
    ,ocs.C_EVFOLYAMTIPUSA as EvfolyamId
    ,dib.C_NAME as EvfolyamNev
  FROM T_OSZTALYCSOPORT_OSSZES ocs
    INNER JOIN T_DICTIONARYITEMBASE dib On dib.ID = ocs.C_EVFOLYAMTIPUSA 
      AND dib.C_TANEVID = ocs.C_TANEVID AND dib.TOROLT = 'F'
    LEFT JOIN T_OSZTALY_OSSZES o ON o.ID = ocs.ID 
      AND (@pAlkalmazottId IS NULL OR (o.C_OSZTALYFONOKID = @pAlkalmazottId OR o.C_OFOHELYETTESID = @pAlkalmazottId))
      AND o.C_ALTANEVID = ocs.C_TANEVID 
      AND o.TOROLT = 'F'
    LEFT JOIN T_CSOPORT_OSSZES cs ON cs.ID = ocs.ID
      AND (@pAlkalmazottId IS NULL OR cs.C_CSOPORTVEZETOID = @pAlkalmazottId)
      AND cs.C_ALTANEVID = ocs.C_TANEVID
      AND cs.TOROLT = 'F'
  WHERE ocs.C_TANEVID = @pTanevID AND COALESCE(o.ID, cs.ID) IS NOT NULL AND ocs.TOROLT = 'F'
END
GO