﻿-- =============================================
-- Description: <Megnézi, hogy van e értékelése a paraméterek alapján>
-- =============================================
DROP PROCEDURE IF EXISTS [dbo].[uspIsTanuloErtekelt]
GO

CREATE PROCEDURE [dbo].[uspIsTanuloErtekelt]
   @pIntezmenyId int
  ,@pTanevId int
  ,@pDatum datetime
  ,@pErtekelesModId int
  ,@pTema nvarchar(2000) = NULL
  ,@pTipusId int
  ,@pTantargyId int
  ,@pTanuloId int 
  ,@pOsztalyzatId int = NULL
  ,@pSzazalek int = NULL
  ,@pErtekelesSzovege nvarchar(max) = NULL
AS
BEGIN

  SET NOCOUNT ON;

  IF EXISTS (
    SELECT 1
    FROM T_TANULOERTEKELES_OSSZES
    WHERE C_INTEZMENYID = @pIntezmenyId
      AND C_TANEVID = @pTanevId
      AND TOROLT = 'F'
      AND C_DATUM = @pDatum 
      AND C_ERTEKELESMODID = @pErtekelesModId
      AND (C_ERTEKELESTEMA = @pTema OR C_ERTEKELESTEMA IS NULL)
      AND C_TIPUSID = @pTipusId 
      AND C_TANTARGYID = @pTantargyId 
      AND (C_TANULOID = @pTanuloId
      AND ((C_ERTEKELESOSZTALYZATID IS NOT NULL AND C_ERTEKELESOSZTALYZATID = @pOsztalyzatId OR
          (C_ERTEKELESSZAZALEK IS NOT NULL AND C_ERTEKELESSZAZALEK = @pSzazalek) OR
          (C_ERTEKELESSZOVEG IS NOT NULL AND C_ERTEKELESSZOVEG = @pErtekelesSzovege))))
  )
    SELECT 1 
  ELSE
    SELECT 0

END

GO
