﻿-- ===================================================================================================
-- KIRSTAT - Felhasználó - NOKS
-- ===================================================================================================
-- 10. MUNKALAP - A02T57 - NEVELŐ ÉS OKTATÓ MUNKÁT KÖZVETLENÜL SEGÍTŐ MUNKAKÖRBEN DOLGOZÓK LÉTSZÁMA, NYITÓADATOK

DROP PROCEDURE IF EXISTS uspKIRstat_FelhasznaloNOKS
GO

CREATE PROCEDURE uspKIRstat_FelhasznaloNOKS
   @pFeladatellatasiHelyId int
  ,@pTanevId int
  ,@pIsKirstat bit = 1
AS
BEGIN
  SET NOCOUNT ON;
  DECLARE 
     @statDatum datetime

  SET @statDatum = (SELECT LEFT(C_NEV, 4) FROM T_TANEV WHERE ID = @pTanevId) + IIF(@pIsKirstat = 1, '1001', '1008')

  SELECT
     C_NYOMTATASINEV AS AlkalmazottNev
    ,CASE C_MUNKAKORTIPUSA
      WHEN 583  THEN 'Titkár'
      WHEN 584  THEN 'Titkár'
      WHEN 6388 THEN 'Titkár'
      WHEN 6438 THEN 'Titkár'
      WHEN 560  THEN 'Dajka'
      WHEN 561  THEN 'Gondozónő és takarító'
      WHEN 589  THEN 'laboráns'
      WHEN 585  THEN 'Pedagógiai asszisztens'  
      WHEN 559  THEN 'Gyógypedagógiai asszisztens'
      WHEN 3026 THEN 'Könyvtáros'                                        
      WHEN 557  THEN 'Szakorvos'                        
      WHEN 563  THEN 'Gyermek- és ifjúságvédelmi felügyelő'
      WHEN 564  THEN 'Szabadidő-szervező'                                        
      WHEN 6421 THEN 'Pszichopedagógus'                                        
      WHEN 565  THEN 'Műszaki vezető'                                        
      WHEN 6382 THEN 'Jelmez és viselet-táros'                                        
      WHEN 566  THEN 'Ápoló'                                         
      WHEN 567  THEN 'Hangszerkarbantartó'                                        
      WHEN 568  THEN 'Úszómester'                                        
      WHEN 594  THEN 'Rendszergazda'                                        
      WHEN 562  THEN 'Pedagógiai felügyelő'                                                                             
      WHEN 579  THEN 'Szociális munkás'                                        
      WHEN 633  THEN 'Gyógytornász'                                      
     END AS Munkakor
    ,IIF(ma.C_RESZMUNKAIDOSZAZALEK < 100, 'T', 'F') AS Reszmunkaidos
    ,IIF(ma.C_MUNKAVISZONYTIPUSA = 654, 'T', 'F') AS Megbizasos
    ,IIF(a.C_KKKEPESITESID = 7244, 'T', 'F') AS Pedagogus
    ,IIF(fh.C_NEME = 5, 'Nő','Férfi') AS Neme
  FROM T_FELHASZNALO_OSSZES fh
    INNER JOIN T_MUNKAUGYIADATOK_OSSZES ma ON fh.ID = ma.C_ALKALMAZOTTID AND ma.TOROLT = 'F'
    INNER JOIN T_ALKALMAZOTT_OSSZES a ON a.ID = fh.ID AND a.TOROLT = 'F'
    LEFT JOIN T_DICTIONARYITEMBASE_OSSZES d ON d.ID = a.C_KKKEPESITESID AND d.C_TANEVID = a.C_ALTANEVID AND d.TOROLT = 'F'
  WHERE C_MUNKAKORTIPUSA IN (583, 584, 6388, 6438, 560, 561, 589, 585, 559, 3026, 557, 563, 564, 6421, 565, 6382, 566, 567, 568, 594, 562, 579, 633)  
    AND a.C_ALLANDOHELYETTESITESRE = 'F' 
    AND ma.C_FELADATELLATASIHELYID = @pFeladatellatasiHelyId
    AND fh.C_TANEVID = @pTanevId
    AND fh.TOROLT = 'F'
END
GO
